/*
  This file is part of the Linux driver for the Eltron p310c plastic card printer
    Copyright (C) 2002 Flemming Frandsen <ff-p310c@partyticket.net>
    Based on initial work by Stian Skjelstad <stian@nixia.no>
    Materials (printer+cards+ribbons) provided by http://www.psi.no/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/
#include "dirty.h"
#include <stdlib.h>

DirtyMap *calculateDirtyMap(CMYKrImage *oldImage, CMYKrImage *newImage) {

    // Now calculate the changed parts of the image 
    // There are DIRTX * DIRTY rectangles in each color.
    DirtyMap *dm = (DirtyMap *)malloc(sizeof(DirtyMap));
    for (int color=0;color<4;color++) {
	dm->dirty[color][0][0] = -1;
    }

    if (oldImage) {
	for (int color=0;color<4;color++) {
	    for (int y=0;y<DIRTY;y++) {
		for (int x=0;x<DIRTX;x++) {
		    dm->dirty[color][x][y] = 0;
		    int base = y*(HEIGHT/DIRTY)*WIDTH + x*(WIDTH/DIRTX);
		    for (int i=0;i<WIDTH/DIRTX;i++) {
			for (int j=0;j<HEIGHT/DIRTY;j++) {
			    int pixel = base+i+j*WIDTH;
			    if (oldImage->color[color][pixel] != newImage->color[color][pixel]) {
				dm->dirty[color][x][y] = 1;
				goto donec;
			    }
			}
		    }
		donec:;
		}
	    }
	}
    }

    return dm;
}
