/*
  This file is part of the Linux driver for the Eltron p310c plastic card printer
    Copyright (C) 2002 Flemming Frandsen <ff-p310c@partyticket.net>
    Based on initial work by Stian Skjelstad <stian@nixia.no>
    Materials (printer+cards+ribbons) provided by http://www.psi.no/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/
#ifndef DIRTY_H
#define DIRTY_H

#include "images.h"

const int DIRTX = 13;
const int DIRTY = 12;

typedef struct {
    int dirty[4][DIRTX][DIRTY];
} DirtyMap;

// Calculate the fields that have changed from the old to the new image:
DirtyMap *calculateDirtyMap(CMYKrImage *oldImage, CMYKrImage *newImage); 

#endif
